---
layout: handbook-page-toc
title: GitLab Dedicated Logs
category: GitLab Dedicated
description: "Gitlab Dedicated Support - Working with logs"
---

## On this page
{:.no_toc .hidden-md .hidden-lg}

- TOC
{:toc .hidden-md .hidden-lg}

# Working with logs

Support can access GitLab Dedicated tenant logs through our [OpenSearch](https://opensearch.org/) infrastructure. See [Accessing logs](#accessing-logs) to get started. 

[OpenSearch](https://opensearch.org/) can be used like [Kibana](./kibana.html) but read about [searching logs](#searching-logs) for information on the differences.

## Identifying tenants

Each customer has a dedicated set of credentials needed for examining logs in Opensearch. The credentials and the URL for that customer's Opensearch instance are stored in the `GitLab Dedicated - Support` [1Password vault](/handbook/security/#vaults). Each customer is noted by a customer number in the vault, so you must refer to the `<tenant name>` to identify the proper credentials to use for a customer. This is used as part of the accessible URL, such as: `opensearch.<tenant name>.gitlab-dedicated.com`.

## Accessing logs

To access the logs for a specific tenant find the credentials stored in the `GitLab Dedicated - Support` Vault, and access the corresponding tenant URL listed there.
Once in the tenant's OpenSearch site:

1. Select "Global" tenant
1. Choose "Discover" at the sidebar under OpenSearch Dashboards
1. On the next screen, you should see logs. Make sure that index `gitlab-*` is selected.

It is recommended to start with the `gitlab-*` index because it has a timestamp field. It shows a useful skyline graph and allows for time-filtering. The `git*` index is less useful as it does not have a timestamp field defined/used.

Logs are retained for 7 days in OpenSearch; retention is longer in S3, but these are not accessible to Support.  Copy and paste relevant log entries or screenshots of frequently occurring errors into an internal note in the ticket or a [field note](./fieldnote_issues.html) in order to preserve them beyond the retention period. 

### Sharing logs
Logs generated by the GitLab application **can** be shared directly with customers via a ticket. Logs that were not generated by the Gitlab application can not be shared with customers. You can determine whether a log entry was generated by the GitLab application by checking:

- Is the `kubernetes.container_name` one of the following?:
  - `gitlab-shell`
  - `gitlab-workhorse`
  - `kas`
  - `registry`
  - `sidekiq`
  - `webservice`  

If **yes**: the log entry **can** be shared directly with the customer via the ticket. 

- Does the `fluentd_tag` have a value of `gitaly.app`?

If **yes**: the log entry **can** be shared directly with the customer via the ticket. 

If one of the criteria above are not met, the log entry can not be shared directly with the customer.

GitLab Dedicated customers can request [access to application logs](https://docs.gitlab.com/ee/administration/dedicated/#access-to-application-logs).  

## Searching logs

Since GitLab Dedicated uses [Cloud Native Hybrid reference architecture](https://docs.gitlab.com/ee/administration/reference_architectures/10k_users.html#cloud-native-hybrid-reference-architecture-with-helm-charts-alternative), searching logs on OpenSearch is a bit different from [Kibana](./kibana.html).

- In OpenSearch, terms can be freely typed in the search bar.
  - By comparison, freely typing in the search bar is [discouraged](kibana.html#fields-and-filters) in Kibana.
- Fields can also be used as filters, similarly to [Kibana](./kibana.html).

### Fields and Filters

The **fields** and **filters** available in OpenSearch can help you to find log entries more easily. 

#### Fields

General fields:

- `host:` The GitLab host of the log. It can be `<tenant name>-gitaly-*`  or  `<tenant name>-consul-2`, etc.
- `referrer:` holds the project path. `https://tenant.gitlab-dedicated.com/example-group/test123`
- `message:` is the message that would be seen in the logs of a self-managed instance.  `xxx.xxx.xxx.xxx - - [08/Jul/2020:13:24:43 +0000] "GET /assets/webpack/commons-pages.projects.show-pages.projects.tree.show.21909065.chunk.js HTTP/1.1" 200 9316 "https://tenant.gitlab-dedicated.com/example-group/test123" "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/102.0.5005.63 Safari/537.36" 1343 0.001 [default-gitlab-webservice-default-8181] [] xxx.xxx.xxx.xxx:8181 9309 0.000 200 fe130eac78314cwf352g3762397572cb`


Gitaly related fields:

- `grpc.request.glProjectPath:` The actual GitLab path project path.
- `grpc.request.repoPath:`  Project hash id path.

SAML related fields:

- `action:saml`
- `path: /users/auth/saml/callback`
- `controller: OmniauthCallbacksController`
- `location: https://tenant.gitlab-dedicated.com/`

#### Filters

- `kubernetes.labels.app:` used to filter Kubernetes pods. `nginx-ingress`, `webservice`, etc.

Use this OpenSearch filter to find logs related to the GitLab application:

- `kubernetes.labels.release: gitlab` 

### Examples

#### Identify a deleted group or project

Information about deleted groups and projects is available in the **Audit Events**. The customer should be able to review this information in the **Admin Area**. Provided the deletion occurred within the log retention window, additional information can be sought in Opensearch. In order to identify more information about a deleted project or group in Opensearch, you can use this information to guide the [filters](#filters) that you use. 

1. Select **Add filter**
1. Click **Select a field first**
1. Choose `meta.caller_id`
1. In the **Operator** drop-down, select `is` 
1. In the **Value**, add `GroupsController#destroy`

You can look at the values in `username`, `user_id` (or `meta.user_id`) to get more information about the user that issued the deletion request. 

